;AKI-H8C^[vO akih8.asm for AT90S1200A
;Copyright (C) 2001 T.Sagae

.include "1200def.inc"

;
;PD0 LED
;PD2 SW
;PD5 RESET
;PD6 12V
;
.equ	STATUS1	= $2D	; 12V:OFF(PD6),RESET=ON(PD5),pullup(PD2,3),LED:OFF(PD0)
.equ	STATUS2	= $6C	; 12V:ON(PD6),RESET=ON(PD5),pullup(PD2,3),LED:ON(PD0)
.equ	STATUS3	= $4C	; 12V:ON(PD6),RESET=OFF(PD5),pullup(PD2,3),LED:ON(PD0)
.equ	STATUS4	= $0D	; 12V:OFF(PD6),RESET=OFF(PD5),pullup(PD2,3),LED:OFF(PD0)
;                            _____________________
;VPP   ----------------------                     ---------------
;
;                 ________       _____________        ___________
;RESET ___________        _______             ________
;
;                            ____________________
;LED_________________________                    ________________
;      reset      run     write                       run
;      STATUS1    STATUS4 S1 S2  STATUS3      S2 S1   S4
;      490ms      -----   10m490m-----        10m490m -----

;*******************
;* Global variable *
;*******************
.def	temp1	= r16	; Work
.def	timer	= r17	; ^C}[JEgp
.def	sv_reg	= r18	; 荞݃[`łSREGۑp


;****************
;* Interruption *
;****************
	rjmp	RESET		; Reset
	reti				; Outside interruption
	rjmp	TIM0_OVF	; Timer/Counter overflow
	reti				; Analog Comparator

RESET:
;******************
;* Initialization *
;******************
	;pb͑Sē
	ldi		temp1,$00
	out		DDRB,temp1

	;SăvAbv
	ldi		temp1,$0FF
	out		PORTB,temp1

	;pd2,pd3 
	ldi		temp1,$0F3
	out		DDRD,temp1

	;pd2,pd3vAbvALEDOFFARESETON
	ldi		temp1,STATUS1
	out		PORTD,temp1

;**** 荞ݏ ****

	; NbN  1/8w
	ldi		temp1,1<<CS01
	out		TCCR0,temp1

	; ^C}[I[o[t[荞݂w
	ldi		temp1,(1<<TOIE0)
	out		TIMSK,temp1

	sei					;荞݋

;**** start ****
	rcall	Wait490ms	; RESETԂێ

	;NɃXCb`Ă炻̂܂܏݃[hɓ
	sbis	PIND,2
	rjmp	write_mode

	;NPD3A[X炻̂܂܏݃[hɓ
	sbis	PIND,3
	rjmp	write_mode

main:
	;runԂɈڂ
	ldi		temp1,STATUS4
	out		PORTD,temp1

main2:
	; L[XCb`̂҂
	sbic	PIND,2
	rjmp	main2

write_mode:
	; ݏԂɑJ
	ldi		temp1,STATUS1
	out		PORTD,temp1
	rcall	Wait10ms

; L[It҂
keyscan:
	sbis	PIND,2
	rjmp	keyscan

	ldi		temp1,STATUS2
	out		PORTD,temp1
	rcall	Wait490ms

	ldi		temp1,STATUS3
	out		PORTD,temp1

	; ݉\
main3:
	; L[XCb`̂҂
	sbic	PIND,2
	rjmp	main3

	ldi		temp1,STATUS2
	out		PORTD,temp1
	rcall	Wait10ms

; L[It҂
keyscan2:
	sbis	PIND,2
	rjmp	keyscan2

	ldi		temp1,STATUS1
	out		PORTD,temp1

	rcall	Wait490ms

	rjmp	main


Wait10ms:
	ldi		timer,5
Wait10ms1:
	cpi		timer,0
	brne	Wait10ms1
	ret

Wait490ms:
	ldi		timer,240
Wait490ms1:
	cpi		timer,0
	brne	Wait490ms1
	ret

;********************
;* ^C}[荞 *
;********************
TIM0_OVF:
	in		sv_reg,SREG

;^C}[̌Z
	cpi		timer,0
	breq	intskip0
	dec		timer
intskip0:

	out		SREG,sv_reg
	reti
